    jQuery(document).ready(function ($) { 
        //Prepare jtable plugin
        $('#CountriesTableContainer').jtable({
            title: emecountries.translate_countries,
            paging: true,
            sorting: true,
            toolbarsearch: true,
            toolbarreset: false,
            jqueryuiTheme: true,
            defaultSorting: 'name ASC',
            selecting: true, //Enable selecting
            multiselect: true, //Allow multiple selecting
            selectingCheckboxes: true, //Show checkboxes on first column
            selectOnRowClick: true, //Enable this to only select using checkboxes
            actions: {
                listAction: ajaxurl+'?action=eme_countries_list',
                deleteAction: ajaxurl+'?action=eme_manage_countries&do_action=deleteCountries&eme_admin_nonce='+emecountries.translate_nonce,
		deleteAction: function (postData) {
                    return $.Deferred(function ($dfd) {
                        $.ajax({
                            url: ajaxurl+'?action=eme_manage_countries&do_action=deleteCountries&eme_admin_nonce='+emecountries.translate_nonce,
                            type: 'POST',
                            dataType: 'json',
                            data: postData,
                            success: function (data) {
                                $dfd.resolve(data);
				if (data.Result=='OK') {
					$('div#countries-message').html(emecountries.translate_deleted);
					$('div#countries-message').show();
					$('div#countries-message').delay(3000).fadeOut('slow');
					$('#CountriesTableContainer').jtable('reload');
				}
                            },
                            error: function () {
                                $dfd.reject();
                            }
                        });
                    });
                },
		updateAction: function (postData) {
                    return $.Deferred(function ($dfd) {
                        $.ajax({
                            url: ajaxurl+'?action=eme_country_edit&eme_admin_nonce='+emecountries.translate_nonce,
                            type: 'POST',
                            dataType: 'json',
                            data: postData,
                            success: function (data) {
                                $dfd.resolve(data);
				if (data.Result=='OK') {
					$('div#countries-message').html(emecountries.translate_updated);
					$('div#countries-message').show();
					$('div#countries-message').delay(3000).fadeOut('slow');
					$('#CountriesTableContainer').jtable('reload');
				}
                            },
                            error: function () {
                                $dfd.reject();
                            }
                        });
                    });
                },
		createAction: function (postData) {
                    return $.Deferred(function ($dfd) {
                        $.ajax({
                            url: ajaxurl+'?action=eme_country_edit&eme_admin_nonce='+emecountries.translate_nonce,
                            type: 'POST',
                            dataType: 'json',
                            data: postData,
                            success: function (data) {
                                $dfd.resolve(data);
				if (data.Result=='OK') {
					$('div#countries-message').html(emecountries.translate_added);
					$('div#countries-message').show();
					$('div#countries-message').delay(3000).fadeOut('slow');
				}
                            },
                            error: function () {
                                $dfd.reject();
                            }
                        });
                    });
                }
            },
            fields: {
                id: {
		    title: emecountries.translate_id,
                    key: true,
                    create: false,
                    edit: false
                },
                alpha_2: {
		    title: emecountries.translate_alpha_2,
                    inputClass: 'validate[required]'
                },
                alpha_3: {
		    title: emecountries.translate_alpha_3,
                    inputClass: 'validate[required]'
                },
                num_3: {
		    title: emecountries.translate_num_3,
                    inputClass: 'validate[required]'
                },
                name: {
		    title: emecountries.translate_name,
                    inputClass: 'validate[required]'
                },
                locale: {
		    title: emecountries.translate_locale
                }
            }
        });

        $('#StatesTableContainer').jtable({
            title: emecountries.translate_states,
            paging: true,
            sorting: true,
            jqueryuiTheme: true,
            defaultSorting: 'name ASC',
            toolbarsearch: true,
            toolbarreset: false,
            selecting: true, //Enable selecting
            multiselect: true, //Allow multiple selecting
            selectingCheckboxes: true, //Show checkboxes on first column
            selectOnRowClick: true, //Enable this to only select using checkboxes
            actions: {
                listAction: ajaxurl+'?action=eme_states_list',
                deleteAction: ajaxurl+'?action=eme_manage_states&do_action=deleteStates&eme_admin_nonce='+emecountries.translate_nonce,
		deleteAction: function (postData) {
                    return $.Deferred(function ($dfd) {
                        $.ajax({
                            url: ajaxurl+'?action=eme_manage_states&do_action=deleteStates&eme_admin_nonce='+emecountries.translate_nonce,
                            type: 'POST',
                            dataType: 'json',
                            data: postData,
                            success: function (data) {
                                $dfd.resolve(data);
				if (data.Result=='OK') {
					$('div#states-message').html(emecountries.translate_deleted);
					$('div#states-message').show();
					$('div#states-message').delay(3000).fadeOut('slow');
					$('#StatesTableContainer').jtable('reload');
				}
                            },
                            error: function () {
                                $dfd.reject();
                            }
                        });
                    });
                },
		updateAction: function (postData) {
                    return $.Deferred(function ($dfd) {
                        $.ajax({
                            url: ajaxurl+'?action=eme_state_edit&eme_admin_nonce='+emecountries.translate_nonce,
                            type: 'POST',
                            dataType: 'json',
                            data: postData,
                            success: function (data) {
                                $dfd.resolve(data);
				if (data.Result=='OK') {
					$('div#states-message').html(emecountries.translate_updated);
					$('div#states-message').show();
					$('div#states-message').delay(3000).fadeOut('slow');
					$('#StatesTableContainer').jtable('reload');
				}
                            },
                            error: function () {
                                $dfd.reject();
                            }
                        });
                    });
                },
		createAction: function (postData) {
                    return $.Deferred(function ($dfd) {
                        $.ajax({
                            url: ajaxurl+'?action=eme_state_edit&eme_admin_nonce='+emecountries.translate_nonce,
                            type: 'POST',
                            dataType: 'json',
                            data: postData,
                            success: function (data) {
                                $dfd.resolve(data);
				if (data.Result=='OK') {
					$('div#states-message').html(emecountries.translate_added);
					$('div#states-message').show();
					$('div#states-message').delay(3000).fadeOut('slow');
				}
                            },
                            error: function () {
                                $dfd.reject();
                            }
                        });
                    });
                }
            },
            fields: {
                id: {
                    key: true,
                    create: false,
                    edit: false
                },
                code: {
		    title: emecountries.translate_code,
                    inputClass: 'validate[required]'
                },
                name: {
		    title: emecountries.translate_name,
                    inputClass: 'validate[required]',
		    display: function (data) {
        		if (data.record.country_id==0) {
				return data.record.name+' '+emecountries.translate_missingcountry;
			} else {
				return data.record.name;
			}
		    }

                },
                country_id: {
		    title: emecountries.translate_country,
		    options: function(data) {
			    	if (data.source == 'list') {
				    //Return url all options for optimization.
				    return ajaxurl+'?list=1&action=eme_countries_options';
				}
			    	// in case it is edit/create:
				return ajaxurl+'?action=eme_countries_options';
		    }
                },
                locale: {
		    title: emecountries.translate_locale,
                    create: false,
                    edit: false
                }
            }
        });
 
        // Load list from server, but only if the container is there
        if ($('#CountriesTableContainer').length) {
           $('#CountriesTableContainer').jtable('load');
        }
        if ($('#StatesTableContainer').length) {
           $('#StatesTableContainer').jtable('load');
        }
 
        // Actions button
        $('#CountriesActionsButton').button().click(function () {
           var selectedRows = $('#CountriesTableContainer').jtable('selectedRows');
           var do_action = $('#eme_admin_action').val();
           var action_ok=1;
           if (selectedRows.length > 0) {
              if ((do_action=='deleteCountries') && !confirm(emecountries.translate_areyousuretodeleteselected)) {
                 action_ok=0;
              }
              if (action_ok==1) {
                 $('#CountriesActionsButton').text(emecountries.translate_pleasewait);
                 var ids = [];
                 selectedRows.each(function () {
                   ids.push($(this).data('record')['id']);
                 });

                 var idsjoined = ids.join(); //will be such a string '2,5,7'
                 $.post(ajaxurl, {'id': idsjoined, 'action': 'eme_manage_countries', 'do_action': do_action, 'eme_admin_nonce': emecountries.translate_nonce }, function() {
			 $('#CountriesTableContainer').jtable('reload');
			 $('#CountriesActionsButton').text(emecountries.translate_apply);
			 if (do_action=='deleteCountries') {
				 $('div#countries-message').html(emecountries.translate_deleted);
				 $('div#countries-message').show();
				 $('div#countries-message').delay(3000).fadeOut('slow');
			 }
                 });
              }
           } else {
              alert(emecountries.translate_pleaseselectrecords);
           }
           // return false to make sure the real form doesn't submit
           return false;
        });
 
        // Actions button
        $('#StatesActionsButton').button().click(function () {
           var selectedRows = $('#StatesTableContainer').jtable('selectedRows');
           var do_action = $('#eme_admin_action').val();
           var action_ok=1;
           if (selectedRows.length > 0) {
              if ((do_action=='deleteStates') && !confirm(emecountries.translate_areyousuretodeleteselected)) {
                 action_ok=0;
              }
              if (action_ok==1) {
                 $('#StatesActionsButton').text(emecountries.translate_pleasewait);
                 var ids = [];
                 selectedRows.each(function () {
                   ids.push($(this).data('record')['id']);
                 });

                 var idsjoined = ids.join(); //will be such a string '2,5,7'
                 $.post(ajaxurl, {'id': idsjoined, 'action': 'eme_manage_states', 'do_action': do_action, 'eme_admin_nonce': emecountries.translate_nonce }, function() {
			 $('#StatesTableContainer').jtable('reload');
			 $('#StatesActionsButton').text(emecountries.translate_apply);
			 if (do_action=='deleteStates') {
				 $('div#states-message').html(emecountries.translate_deleted);
				 $('div#states-message').show();
				 $('div#states-message').delay(3000).fadeOut('slow');
			 }
                 });
              }
           } else {
              alert(emecountries.translate_pleaseselectrecords);
           }
           // return false to make sure the real form doesn't submit
           return false;
        });
     });
